#
# PLDBBS LILY2ND SAPA - Function Engine bulid 1101 b1
#
# Copyright(c)Maylily/AO2, Luciel. 1999.
#     http://myhome.shinbiro.com/~maylily/
#     http://luciel.pr.co.kr
#     http://free.soranet.com/~luciel/pldbbs/
#
# Cookie Library by
#     (C)Aromi. 1999. (http://aromi.ms98.net)
#
$sver = "1101b1";

require "setting.pl";

$Cookie_Exp_Date = '';
@Cookie_Encode_Chars = ('\%', '\+',  '\;', '\,',  '\=', '\&',  '\:\:', '\s');
%Cookie_Encode_Chars = ('\%', '%25', '\+', '%2B', '\;', '%3B', '\,',   '%2C',
                        '\=', '%3D', '\&', '%26', '\:\:', '%3A%3A', '\s', '+');
@Cookie_Decode_Chars = ('\+', '\%3A\%3A', '\%26', '\%3D', '\%2C', '\%3B', '\%2B', '\%25');
%Cookie_Decode_Chars = ('\+', ' ', '\%3A\%3A', '::', '\%26',  '&', '\%3D',  '=',
                        '\%2C',  ',', '\%3B',  ';', '\%2B',  '+', '\%25',  '%');


&get_cookie;
&read_ini;


sub parse_input {
    local($method) = $ENV{'REQUEST_METHOD'};
    if(defined(@_)) { local(*input) = @_; }
    else { local(*input) = "*IN"; }

    if ($method eq 'POST') {
            read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
            $ENV{'QUERY_STRING'} = $buffer;
    }
    else { $buffer = $ENV{'QUERY_STRING'}; }
    @pairs = split(/&/, $buffer);
    foreach $pair (@pairs) {
        ($key, $value) = split(/=/, $pair);
        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
        $FORM{$key} = $value;
    }
}

sub get_file {
    local($html) = @_; local(@data);
    &lock;
    open(DATA, $html);
    @data = <DATA>; unless (close(DATA)) { &unlock; return "err" };
    &unlock;
    return @data;
}

sub get_style {

    $skin = 'style' if ($skin eq '');
    @vstyle = &get_file($skin . "_v.html");
    if ($vstyle[0] eq "err") {
        @vstyle = &get_file("style_v.html");
        &open_err("  ", "style_v.html    ϴ.") if ($vstyle[0] eq "err");
        $fflag = 1;
    }

    @mstyle = &get_file($skin . "_m.html");
    if ($mstyle[0] eq "err") {
        @mstyle = &get_file("style_m.html");
        &open_err("  ", "style_m.html    ϴ.") if ($mstyle[0] eq "err");
        $fflag = 1;
    }

    @wstyle = &get_file($skin . "_w.html");
    if ($wstyle[0] eq "err") {
        @wstyle = &get_file("style_w.html");
        &open_err("  ", "style_w.html    ϴ.") if ($wstyle[0] eq "err");
        $fflag = 1;
    }
    @rstyle = &get_file($skin . "_r.html");

    if ($rstyle[0] eq "err") {
        if ($fflag != 1) { @rstyle = "<!--reply-->"; }
        else {
            @rstyle = &get_file("style_r.html");
            @rstyle = "<!--reply-->" if ($rstyle[0] eq "err");
        }
    }

    @tstyle = &get_file($skin . "_t.html");
    if ($tstyle[0] eq "err") {
        @tstyle = @vstyle;
        foreach $line (@tstyle) {
            $line =~ s/<!--reply-->/@rstyle/ig;
            $line =~ s/<!--reply_file-->/@rstyle/ig;
        }
    }
}

sub get_time {
    $time = time;
    local($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($time);
    $sec   = "0" . $sec  if ($sec  < 10);
    $min   = "0" . $min  if ($min  < 10);
    $hour  = "0" . $hour if ($hour < 10);
    $mday  = "0" . $mday if ($mday < 10);
    local $month = $mon + 1;
    $month = "0" . $month if ($month < 10);
    $thisday = (Sun,Mon,Tue,Wed,Thu,Fri,Sat) [$wday];
    if ($year > 99) {
        $year -= 100;
        $year = "0" . $year if ($year < 10);
        $year = "20" . $year;
    }
    else {
        $year = "19" . $year;
    }
    $wdate  = "$year/$month/$mday ($thisday) $hour:$min:$sec";
    $rdate  = "$year/$month/$mday ($thisday) $hour:$min:$sec";
    $mo = $month;
    $day = $mday;
}


sub get_cookie {
    @COOKIES = split(/; /,$ENV{'HTTP_COOKIE'});
    foreach (@COOKIES) {
        ($ck_name,$ck_value) = split(/=/,$_);
        $COOKIE{$ck_name} = $ck_value;
    }
    ($cookie_id,$cookie_passwd) = split(/:/,$COOKIE{"AO2_Admin_Cookie"});
    unless (($PLDENV{'admin_id'} ne $cookie_id) and ($PLDENV{'admin_passwd'} ne $cookie_passwd)) {
        $cookie_id = ''; $cookie_passwd = '';
    }
    &GetCompressedCookies("pldbbs");

    $name = $Cookies{'name'};
    $email = $Cookies{'email'};
    $home = $Cookies{'home'};
    $mo = $Cookies{'mo'};
    $day = $Cookies{'day'};
    $cicon = $Cookies{'icon'};
    $skin = $Cookies{'skin'};
    $written = $Cookies{'written'};
}

sub make_index {
    print "<!--Index recreated!-->\n";
    &lock;
    open(IDX, ">$PLDENV{'data_dir'}/$PLDENV{'idx_file'}") || &open_err("ε  ", "$PLDENV{'data_dir'}/$PLDENV{'idx_file'} ۹̼ Ȯֽʽÿ. ε  µ Ͽ");
    $PLDENV{'max_search'} = 500 if ($PLDENV{'max_search'} == 0);
    for ($i = $PLDENV{'max_search'} - 2; $i >= 0 ; $i--) {
        if (open(FILE,"$PLDENV{'data_dir'}/$FILES[$i]")) {
            @LINES = <FILE>;
            local($name,$email,$home,$date,$rdate,$icon) = split(/\|/,$LINES[0]);
            print IDX "$FILES[$i]|$name|$icon\n" if ($name ne '' && $FILES[$i] ne '');
            close(FILE);
        }
    }
    close(IDX);
    &unlock;
}

sub default_ini { for ($i = 0; $i <= $#env_sect; $i++) { $PLDENV{$env_sect[$i]} = $env_value[$i]; }}

sub read_ini {
    &default_ini;
    @DATA = &get_file($inifile);
    &make_ini if ($DATA[0] eq 'err');
    chomp(@DATA);
    foreach $ini_value (@DATA) {
        ($inisect, $value) = split(/=/, $ini_value, 2);
        $PLDENV{$inisect} = $value;
    }
}

sub make_ini {
    &lock;
    open(INI, ">$inifile") || &open_err("INI   ", "$inifile  ۹̼ üũּ.");
    for ($i = 0; $i <= $#env_sect; $i++) { print INI "$env_sect[$i]=$PLDENV{$env_sect[$i]}\n"; }
    close(INI);
    &unlock;
}


sub open_err {
    local($location, $message) = @_;

    print "Content-type: text/html\n";
    print "Pragma: no-cache\n\n";

    print "<HTML><HEAD><TITLE>500 CGI internal Error</TITLE></HEAD>\n";
    print "<BODY><H1>500 CGI internal Error</H1>\n";
    print "$location  ο ߻߽ϴ. <BR><BR>\n";
    print "Please contact the <A HREF=mailto:$PLDENV{'admin'}>Webmaster</A>\n";
    print "and inform them of the time occurred, and\n";
    print " anything you might have done that may have caused the error.<BR><BR>\n";
    print "<b>$soft</b> - build $ver ($dver) / <b>subfnc</b> - build $sver<BR><BR>\n";
    print "<B>Error:  $message </B><BR><BR>\n";
    print "</BODY></HTML>\n";

    &unlock;
    exit;
}


sub time_conv {
    my ($year, $month, $date, $hour, $minute, $second, $gmt) = @_;
    my $re_time, $tmp, $month_tmp;
    my @month_arr = (31, 0, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
    if($year < 1970 || $year > 2070) { return 0; }
    if($month > 3) {
        foreach $month_tmp(1..$month-1) {
            if($month_tmp eq 2) { $re_time += (&February($year)*86400); }
            else { $re_time += ($month_arr[$month_tmp-1]*86400); }
        }
    }
    else {
        $re_time += ((&February($year)*86400) + (31*86400)) if ($month eq 3);
        $re_time += (31*86400) if ($month eq 2);
    }

    $re_time += &year_2_time($year);
    $re_time += ($date-1)*86400;
    $re_time += $hour*3600;
    $re_time += $minute*60;
    $re_time += $second;
    $re_time -= $gmt*3600;
    return $re_time;
}


sub February { my ($year) = @_; (($year-1972)%4) && return 28; return 29; }


sub year_2_time { 
    my ($year) = @_; my $sum, $year_tmp;
    if($year > 1970) { foreach $year_tmp(1971..$year) { $sum += 86400 *(337+&February($year_tmp)); } }
    return $sum;
}

sub header {
    print "Content-type: text/html; charset=EUC-KR\n";
    print "Pragma: no-cache\n\n";
    print "<!--P U R E L I F E D R E A M S A P A (lily2nd ported) - $dver\n";
    print "  (C)1999,.LUCIEL. (http://luciel.pr.co.kr/)\n";
    print "  (C)1999,.MAYLILY/AO2. (http://myhome.shinbiro.com/~maylily/)\n";
    print "  $soft - build $ver / subfnc - build $sver -->\n\n";
}

sub view_write {

    @signtemp = @wstyle;
    foreach $inline (@signtemp) {
        $inline =~ s/FORM_p/$FORM{'p'}/i;
        if ($inline =~ /<!--write_error-->/){
            if ($error == 1) { $inline =~ s/<!--write_error-->/$error1/i; }
            else { $inline =~ s/<!--write_error-->//i; }
        }
        $inline =~ s/(name="name")/$1 value="$name"/i;
        $inline =~ s/(name="email")/$1 value="$email"/i;
        $inline =~ s/(name="home")/$1 value="$home"/i;
        $inline =~ s/<!--comment-->/$FORM{'comment'}/i;

        if ($inline =~ m/<!--icon_list-->/) {
            @ICONS = &get_file("icons.dat");
            chop(@ICONS);
            $iclist = 0; undef($icln);
            until ($iclist > $#ICONS) {
                if ($ICONS[$iclist] =~ m/\|/) {
                    local($ifname, $icmt) = split(/\|/,$ICONS[$iclist]);
                    if ($ifname ne $cicon) { $icln .= "<OPTION VALUE='$ifname'>$icmt\n"; }
                    else { $icln .= "<OPTION VALUE='$ifname' SELECTED>$icmt\n"; }
                }
                elsif ($ICONS[$iclist] !~ /^#/ and $ICONS[$iclist] ne '')  {
                    &open_err("߸ ", "icons.dat   ʰų Ŀ  ʽϴ. Ǵ ASCII  ϵ ʾҽϴ.");
                }
                $iclist++;
            }
            $inline =~ s/<!--icon_list-->/$icln/i;
        }
        print $inline;
    }
}

sub lock {
    local($retry) = 10;
    local($flag) = 0;
    local($lockfile) = $PLDENV{'lock_file'};

    if ($PLDENV{'lock'} == 1) { # by symlink lock
        while (!symlink(".", $lockfile)) {
            if (--$retry <=0 ) {
                unlink($lockfile) if (-e $lockfile);
                &open_err("File Lock", "BUSY : $!");
            }
            sleep(1);
        }
    } elsif ($PLDENV{'lock'} == 2) { # by open lock
        foreach (1 .. $retry) {
            if (-e "$lockfile") { sleep(1); }
            else {
                open(LOCK, ">$lockfile");
                close(LOCK) || &open_err("File Lock", "$lockfile Ͽ   ϴ : $!");
                $flag = 1;
                last;
            }
        }
        if ($flag == 0) { &open_err("File Lock", "BUSY : $!"); }
    }
}

sub unlock { unlink($PLDENV{'lock_file'}) if (-e $PLDENV{'lock_file'}); }


sub SetCookieExpDate {
    if ($_[0] =~ /^\w{3}\,\s\d{2}\-\w{3}-\d{4}\s\d{2}\:\d{2}\:\d{2}\sGMT$/ || $_[0] eq '') {
        $Cookie_Exp_Date = $_[0];
        return 1;
    }
    else { return 0; }
}

sub SetCookieExpDateEx {
    local($csec,$cmin,$chour,$cmday,$cmon,$cyear,$cwday,$cyday,$cisdst, $cwdays,$cmonth,$GMTDATE);
    ($csec,$cmin,$chour,$cmday,$cmon,$cyear,$cwday,$cyday,$cisdst) = gmtime( time + $_[0] );
    $cyear += 1900;
    $cwdays = ("Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat")[$cwday];
    $cmonth = ("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec")[$cmon];
    $GMTDATE = sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT", $cwdays, $cmday, $cmonth, $cyear, $chour, $cmin, $csec);
    return &SetCookieExpDate( $GMTDATE );
}

sub SetCookies {
    local(@cookies) = @_;
    local($cookie,$value,$char);

    while( ($cookie,$value) = @cookies ) {
        foreach $char (@Cookie_Encode_Chars) {
            $cookie =~ s/$char/$Cookie_Encode_Chars{$char}/g;
            $value =~ s/$char/$Cookie_Encode_Chars{$char}/g;
        }
        print 'Set-Cookie: ' . $cookie . '=' . $value . ';';
        print ' expires=' . $Cookie_Exp_Date . ';' if ($Cookie_Exp_Date);
        print "\n";
        shift(@cookies); shift(@cookies);
    }
}

sub SetCompressedCookies {
    local($cookie_name,@cookies) = @_;
    local($cookie,$value,$cookie_value);

    while ( ($cookie,$value) = @cookies ) {
        foreach $char (@Cookie_Encode_Chars) {
            $cookie =~ s/$char/$Cookie_Encode_Chars{$char}/g;
            $value =~ s/$char/$Cookie_Encode_Chars{$char}/g;
        }
        if ($cookie_value) { $cookie_value .= '&' . $cookie . '::' . $value; }
        else { $cookie_value = $cookie . '::' . $value; }
        shift(@cookies); shift(@cookies);
    }

    &SetCookies("$cookie_name","$cookie_value");
}

sub GetCookies {
    local($cookie_flag) = 0;
    local($cookie,$value);

    if ($ENV{'HTTP_COOKIE'}) {
        foreach (split(/; /,$ENV{'HTTP_COOKIE'})) {
            ($cookie,$value) = split(/=/);
            foreach $char (@Cookie_Decode_Chars) {
                $cookie =~ s/$char/$Cookie_Decode_Chars{$char}/g;
                $value =~ s/$char/$Cookie_Decode_Chars{$char}/g;
            }
            $Cookies{$cookie} = $value;
        }
        $cookie_flag = 1;
    }
    return $cookie_flag;
}

sub GetCompressedCookies {
    local($cookie_name) = @_;
    local($cookie_flag) = 0;
    local($cookie,$value);

    if (&GetCookies()) {
        return 0 if( $Cookies{$cookie_name} eq "" );
        foreach (split(/&/,$Cookies{$cookie_name})) {
            ($cookie,$value) = split(/::/);
            foreach $char (@Cookie_Decode_Chars) {
                $cookie =~ s/$char/$Cookie_Decode_Chars{$char}/g;
                $value =~ s/$char/$Cookie_Decode_Chars{$char}/g;
            }
            $Cookies{$cookie} = $value;
        }
        $cookie_flag = 1;
    }

    delete($Cookies{$cookie_name});

    return $cookie_flag;
}

sub encode {
    local($raw, $salt) = @_; local($encoded);
    $salt = substr($salt, -2, 2);
    $encoded = crypt($raw, $salt);
    return $encoded;
}

1;
